## aiide_2017_bot_submissions.zip

=== SparCraft/Makefile ===
CC=g++
BWAPI_DIR=/home/dave/facebook/bwapi/bwapi
SDL_LDFLAGS=`sdl2-config --libs` 
SDL_CFLAGS=`sdl2-config --cflags` 
CFLAGS=-O3 -std=c++11 $(SDL_CFLAGS)
LDFLAGS=-lGL -lGLU -lSDL2_image $(SDL_LDFLAGS)
INCLUDES=-I$(BWAPI_DIR)/include -I$(BWAPI_DIR)/include/BWAPI -I$(BWAPI_DIR)
SOURCES=$(wildcard $(BWAPI_DIR)/BWAPILIB/Source/*.cpp) $(wildcard $(BWAPI_DIR)/BWAPILIB/*.cpp) $(wildcard source/*.cpp) $(wildcard source/main/*.cpp) $(wildcard source/gui/*.cpp)
OBJECTS=$(SOURCES:.cpp=.o)

all:SparCraft 

SparCraft:$(OBJECTS) 
	$(CC) $(OBJECTS) -o bin/$@  $(LDFLAGS)

.cpp.o:
	$(CC) -c $(CFLAGS) $(INCLUDES) $< -o $@ 
.cc.o:
	$(CC) -c $(CFLAGS) $(INCLUDES) $< -o $@

=== CherryPi/rttr/CMakeLists.txt ===
####################################################################################
#                                                                                  #
#  Copyright (c) 2014, 2015 - 2017 Axel Menzel <info@rttr.org>                     #
#                                                                                  #
#  This file is part of RTTR (Run Time Type Reflection)                            #
#  License: MIT License                                                            #
#                                                                                  #
#  Permission is hereby granted, free of charge, to any person obtaining           #
#  a copy of this software and associated documentation files (the "Software"),    #
#  to deal in the Software without restriction, including without limitation       #
#  the rights to use, copy, modify, merge, publish, distribute, sublicense,        #
#  and/or sell copies of the Software, and to permit persons to whom the           #
#  Software is furnished to do so, subject to the following conditions:            #
#                                                                                  #
#  The above copyright notice and this permission notice shall be included in      #
#  all copies or substantial portions of the Software.                             #
#                                                                                  #
#  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR      #
#  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,        #
#  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE     #
#  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER          #
#  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,   #
#  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE   #
#  SOFTWARE.                                                                       #
#                                                                                  #
####################################################################################

####################################################################################
# Welcome to the CMake build system for RTTR( Run Time Type Reflection).           #
# This is the main file where the general build environment is set-up and the      #
# the build configuration options are initialized.                                 #
####################################################################################

cmake_minimum_required (VERSION 2.8.12)

project ("rttr")

set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/CMake")

if (CMAKE_BUILD_TYPE STREQUAL "")
  # CMake defaults to leaving CMAKE_BUILD_TYPE empty. This screws up
  # differentiation between debug and release builds.
  set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "Choose the type of build, options are: None (CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel." FORCE)
endif ()

# our little cmake helper functions
include(utility)

# set up option variable for cmake
option(BUILD_RTTR_DYNAMIC "Build the dynamic/shared version of RTTR library" ON)
option(BUILD_UNIT_TESTS "Build the unit tests of RTTR" ON)
option(BUILD_STATIC "Build RTTR as static library" OFF)
option(BUILD_WITH_STATIC_RUNTIME_LIBS "Link against the static runtime libraries" OFF)
option(BUILD_WITH_RTTI "Enable build with C++ runtime type information for compilation" ON)
option(BUILD_BENCHMARKS "Enable this to build the benchmarks" ON)
option(BUILD_EXAMPLES "Enable this to build the examples" ON)
option(BUILD_DOCUMENTATION "Enable this to build the documentation" ON)
option(BUILD_INSTALLER "Enable this to build the installer" ON)
option(BUILD_PACKAGE "Enable this to build the installer" ON)
option(USE_PCH "Use precompiled header files for compilation" ON)
option(CUSTOM_DOXYGEN_STYLE "Enable this option to use a custom doxygen style for HTML documentation; Otherwise the default will be used" ON)
option(BUILD_WEBSITE_DOCU "Enable this option to create the special docu for the website" OFF)

# one precompiled headers cannot be used for multiple ninja targets
# thats why we have to disable this option, when BUILD_STATIC or
# BUILD_WITH_STATIC_RUNTIME_LIBS is ON (every target will create the same PCH.pch file)
# to get it working, we need the feature to enable different source properties
# for different targets
if (USE_PCH)
  if (BUILD_STATIC OR BUILD_WITH_STATIC_RUNTIME_LIBS)
    set(USE_PCH FALSE)
  endif()
endif()

include(config)
include(3rd_party_libs)

if (BUILD_PACKAGE)
    include(installer)
endif()

# here we add our source code
add_subdirectory(src)
# and the documentation
if (BUILD_DOCUMENTATION)
    add_subdirectory(doc)
endif()

# here we specify the installation directory
if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
  set(CMAKE_INSTALL_PREFIX ${RTTR_INSTALL_DIR} CACHE PATH  "RTTR install prefix" FORCE)
endif()

=== CherryPi/torchcraft/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.6 FATAL_ERROR)
CMAKE_POLICY(VERSION 2.6)
IF(LUAROCKS_PREFIX)
    MESSAGE(STATUS "Installing TorchCraft through Luarocks")
    STRING(REGEX REPLACE "(.*)lib/luarocks/rocks.*" "\\1" CMAKE_INSTALL_PREFIX  "${LUAROCKS_PREFIX}")
    MESSAGE(STATUS "Prefix inferred from Luarocks: ${CMAKE_INSTALL_PREFIX}")
ENDIF()
FIND_PACKAGE(Torch REQUIRED)
FIND_PACKAGE(PkgConfig REQUIRED)
PKG_CHECK_MODULES(ZSTD libzstd>=1.0)

SET(CMAKE_CXX_FLAGS "-std=c++11 -Wall -fPIC -O2")
IF(ZSTD_FOUND)
    ADD_DEFINITIONS(-DWITH_ZSTD)
ENDIF()

INCLUDE_DIRECTORIES(
    ${CMAKE_CURRENT_SOURCE_DIR}/include
    ${CMAKE_CURRENT_SOURCE_DIR}/lua
    ${CMAKE_CURRENT_SOURCE_DIR}/replayer
    ${CMAKE_CURRENT_SOURCE_DIR}/client)

# A pure (non-Lua) C++ library containing the main client functionality
FILE(GLOB headers include/*.h)
FILE(GLOB cppsrc replayer/*.cpp client/*.cpp)
ADD_LIBRARY(torchcraft SHARED ${cppsrc})
IF(APPLE)
   SET_TARGET_PROPERTIES(torchcraft PROPERTIES
       LINK_FLAGS "-undefined dynamic_lookup")
ENDIF()
SET_TARGET_PROPERTIES(torchcraft PROPERTIES
    VERSION   1.3.3
    SOVERSION 1.3.3)
TARGET_LINK_LIBRARIES(torchcraft TH luaT zmq)
IF(ZSTD_FOUND)
    # Use the static library since we're using "advanced/experimental" features
    TARGET_LINK_LIBRARIES(torchcraft ${ZSTD_LIBDIR}/libzstd.a)
ENDIF()
INSTALL(FILES ${headers}
        DESTINATION "${Torch_INSTALL_INCLUDE}/torchcraft"
)
INSTALL(TARGETS torchcraft
    LIBRARY DESTINATION ${Torch_INSTALL_LIB})

# The lua module, including a lua wrapper for the general client library
FILE(GLOB luasrc *.lua)
FILE(GLOB cppsrc_lua lua/*.cpp)
ADD_LIBRARY(tc_lib MODULE ${cppsrc_lua})
SET_TARGET_PROPERTIES(tc_lib PROPERTIES
   PREFIX ""
   IMPORT_PREFIX "")
IF(APPLE)
   SET_TARGET_PROPERTIES(tc_lib PROPERTIES
       LINK_FLAGS "-undefined dynamic_lookup")
ENDIF()
TARGET_LINK_LIBRARIES(tc_lib TH luaT torchcraft)
INSTALL(TARGETS tc_lib
        DESTINATION "${LIBDIR}/torchcraft"
)

ADD_TORCH_PACKAGE(torchcraft "" "${luasrc}" "TorchCraft")
INSTALL(FILES DESTINATION "${Torch_INSTALL_LUA_PATH_SUBDIR}/torchcraft")

=== CherryPi/rttr/doc/CMakeLists.txt ===
####################################################################################
#                                                                                  #
#  Copyright (c) 2014, 2015 - 2017 Axel Menzel <info@rttr.org>                     #
#                                                                                  #
#  This file is part of RTTR (Run Time Type Reflection)                            #
#  License: MIT License                                                            #
#                                                                                  #
#  Permission is hereby granted, free of charge, to any person obtaining           #
#  a copy of this software and associated documentation files (the "Software"),    #
#  to deal in the Software without restriction, including without limitation       #
#  the rights to use, copy, modify, merge, publish, distribute, sublicense,        #
#  and/or sell copies of the Software, and to permit persons to whom the           #
#  Software is furnished to do so, subject to the following conditions:            #
#                                                                                  #
#  The above copyright notice and this permission notice shall be included in      #
#  all copies or substantial portions of the Software.                             #
#                                                                                  #
#  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR      #
#  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,        #
#  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE     #
#  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER          #
#  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,   #
#  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE   #
#  SOFTWARE.                                                                       #
#                                                                                  #
####################################################################################

find_package(Doxygen)
# These variables are defined in the doxygen file(@VAR@) as place holders
# an will be substituted by the following values
set(DOXYGEN_PROJECT_NUMBER    "${RTTR_VERSION_STR}")
set(DOXYGEN_PROJECT_NAME      "${PROJECT_NAME}")
set(DOXYGEN_INPUT_DIRECTORY   "${CMAKE_SOURCE_DIR}/src/rttr \\
                               ${CMAKE_CURRENT_SOURCE_DIR}" )
set(DOXYGEN_OUTPUT_DIRECTORY  "${CMAKE_BINARY_DIR}/doc")
set(DOXYGEN_DOC_INSTALL_DIR   "doc")
set(DOXYGEN_CONFIG_FILE_IN    "DoxyFile.cfg.in")
set(DOXYGEN_LAYOUT_FILE_IN    "doxygen-customization/layout/DoxygenLayout.xml.in")
set(DOXYGEN_EXCLUDE           "")
set(DOXYGEN_STRIP_FROM_PATH   "${CMAKE_SOURCE_DIR}/src/rttr")
set(DOXYGEN_CUSTOM_HTML_DIR   "rttr-${RTTR_VERSION_MAJOR}-${RTTR_VERSION_MINOR}-${RTTR_VERSION_PATCH}")
set(DOXYGEN_PREDEFINED        "DOXYGEN \\
                               RTTR_INLINE= \\
                               RTTR_FORCE_INLINE= \\
                               RTTR_API= \\
                               RTTR_NOEXCEPT=noexcept \\
                               RTTR_CONSTEXPR=constexpr \\
                               RTTR_CXX14_CONSTEXPR=constexpr \\
                               RTTR_STATIC_CONSTEXPR=static constexpr \\
                               RTTR_NOEXCEPT_OR_NOTHROW=throw() \\
                               RTTR_DEPRECATED_WITH_MSG= \\
                               ")
set(DOXYGEN_EXCLUDE_SYMBOLS   "impl* \\
                               impl::* \\
                               detail* \\
                               detail:: \\
                               ")

set(DOXYGEN_EXCLUDE_PATTERNS  "*.cpp* \\
                              *_p.cpp* \\
                              *PCH.h* \\
                              *_impl.h* \\
                              *_p.h* \\
                              */src/rttr/detail/* \\
                              */src/test/* \\
                              */src/benchmark/*")

set(DOXYGEN_INDEX_FILE_IN   "index.html.in")

#### LAYOUT VARIABLES
set(DOXY_LAYOUT_MAIN_PAGE_TITLE "RTTR")
set(DOXY_LAYOUT_PAGES_TITLE     "Tutorial")
set(DOXY_LAYOUT_PAGES_TITLE2    "Installation")
set(DOXY_LAYOUT_PAGES_TITLE3    "License")


if (${CUSTOM_DOXYGEN_STYLE})
  set(DOXYGEN_CUSTOM_HTML_FOOTER     "${CMAKE_CURRENT_SOURCE_DIR}/doxygen-customization/html/footer.html")
  set(DOXYGEN_CUSTOM_HTML_HEADER     "${CMAKE_CURRENT_SOURCE_DIR}/doxygen-customization/html/header.html")
  set(DOXYGEN_CUSTOM_HTML_STYLESHEET "${CMAKE_CURRENT_SOURCE_DIR}/doxygen-customization/css/custom-doxygen.css")
endif()

if(NOT DOXYGEN_FOUND)
  message(WARNING "Doxygen not found - Documentation will not be generated!")
  return()
endif()

string ( REGEX REPLACE ".cfg.in$" ".cfg" DOXYGEN_CONFIG_FILE ${DOXYGEN_CONFIG_FILE_IN} )
string ( REGEX REPLACE ".html.in$" ".html" DOXYGEN_INDEX_FILE ${DOXYGEN_INDEX_FILE_IN} )
string ( REGEX REPLACE ".xml.in$" ".xml" DOXYGEN_LAYOUT_FILE ${DOXYGEN_LAYOUT_FILE_IN} )
string ( REGEX REPLACE "[^\\/]*/(.*)" "\\1" DOXYGEN_LAYOUT_FILE "${DOXYGEN_LAYOUT_FILE}")

if(NOT EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${DOXYGEN_CONFIG_FILE_IN})
  message(WARNING "Doxygen configuration file not found - Documentation will not be generated!")
  return()
endif()

# modify the doxygen file, i.e. substitute the variables with values
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${DOXYGEN_CONFIG_FILE_IN} ${DOXYGEN_OUTPUT_DIRECTORY}/${DOXYGEN_CONFIG_FILE})
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${DOXYGEN_LAYOUT_FILE_IN} ${DOXYGEN_OUTPUT_DIRECTORY}/${DOXYGEN_LAYOUT_FILE})
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${DOXYGEN_INDEX_FILE_IN} ${DOXYGEN_OUTPUT_DIRECTORY}/${DOXYGEN_INDEX_FILE})
# copy our shortcut html file (this 'index.html' will call itself the 'index.html' from doxygen,
# but this file is hard to locate in the big doxygen output directory)
#file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/index.html DESTINATION ${DOXYGEN_OUTPUT_DIRECTORY})

if (${CUSTOM_DOXYGEN_STYLE})
  #fonts
  file(COPY  ${CMAKE_CURRENT_SOURCE_DIR}/doxygen-customization/fonts/ptsans_regular_macroman DESTINATION ${DOXYGEN_OUTPUT_DIRECTORY}/${DOXYGEN_CUSTOM_HTML_DIR}/fonts)
  file(COPY  ${CMAKE_CURRENT_SOURCE_DIR}/doxygen-customization/fonts/source_code_pro_regular DESTINATION ${DOXYGEN_OUTPUT_DIRECTORY}/${DOXYGEN_CUSTOM_HTML_DIR}/fonts)


  #bootstrap
  file(COPY  ${CMAKE_CURRENT_SOURCE_DIR}/doxygen-customization/3rd-party/bootstrap-3.3.2/css/bootstrap.min.css DESTINATION ${DOXYGEN_OUTPUT_DIRECTORY}/${DOXYGEN_CUSTOM_HTML_DIR}/bootstrap/css)
  file(COPY  ${CMAKE_CURRENT_SOURCE_DIR}/doxygen-customization/3rd-party/bootstrap-3.3.2/js/bootstrap.min.js DESTINATION ${DOXYGEN_OUTPUT_DIRECTORY}/${DOXYGEN_CUSTOM_HTML_DIR}/bootstrap/js)
  file(COPY  ${CMAKE_CURRENT_SOURCE_DIR}/doxygen-customization/css/custom-bootstrap.css DESTINATION ${DOXYGEN_OUTPUT_DIRECTORY}/${DOXYGEN_CUSTOM_HTML_DIR})
  #jquery
  file(COPY  ${CMAKE_CURRENT_SOURCE_DIR}/doxygen-customization/3rd-party/jquery-2.1.3/jquery.min.js DESTINATION ${DOXYGEN_OUTPUT_DIRECTORY}/${DOXYGEN_CUSTOM_HTML_DIR})
  #the connection between the doxygen style and the bootstrap style
  file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/doxygen-customization/js/doxy-boot.js DESTINATION ${DOXYGEN_OUTPUT_DIRECTORY}/${DOXYGEN_CUSTOM_HTML_DIR})
  file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/doxygen-customization/img/favicon.ico DESTINATION ${DOXYGEN_OUTPUT_DIRECTORY}/${DOXYGEN_CUSTOM_HTML_DIR})
endif()

#########################################################################################

add_custom_target(doc ALL
                  COMMAND "${DOXYGEN_EXECUTABLE}" "${DOXYGEN_OUTPUT_DIRECTORY}/${DOXYGEN_CONFIG_FILE}"
                  WORKING_DIRECTORY "${DOXYGEN_OUTPUT_DIRECTORY}"
                  COMMENT "Building documentation...")

set_target_properties(doc PROPERTIES FOLDER "Documentation")

install(DIRECTORY "${DOXYGEN_OUTPUT_DIRECTORY}/${DOXYGEN_CUSTOM_HTML_DIR}"
        DESTINATION "${DOXYGEN_DOC_INSTALL_DIR}"
        PATTERN "*.*"
        PERMISSIONS OWNER_READ)

install(FILES "${DOXYGEN_OUTPUT_DIRECTORY}/${DOXYGEN_INDEX_FILE}"
        DESTINATION "${DOXYGEN_DOC_INSTALL_DIR}"
        PERMISSIONS OWNER_READ)

#########################################################################################

if (BUILD_WEBSITE_DOCU)
    set(DOXYGEN_OUTPUT_DIRECTORY        "${CMAKE_BINARY_DIR}/doc_website")
    set(DOXYGEN_CUSTOM_HTML_FOOTER      "${CMAKE_CURRENT_SOURCE_DIR}/doxygen_website_customization/html/footer.html")
    set(DOXYGEN_CUSTOM_HTML_HEADER      "${CMAKE_CURRENT_SOURCE_DIR}/doxygen_website_customization/html/header.html")
    set(DOXYGEN_CUSTOM_HTML_STYLESHEET  "${CMAKE_CURRENT_SOURCE_DIR}/doxygen_website_customization/css/custom-doxygen.css")
    set(DOXYGEN_CUSTOM_HTML_DIR         "master")
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${DOXYGEN_CONFIG_FILE_IN} ${DOXYGEN_OUTPUT_DIRECTORY}/${DOXYGEN_CONFIG_FILE})
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${DOXYGEN_LAYOUT_FILE_IN} ${DOXYGEN_OUTPUT_DIRECTORY}/${DOXYGEN_LAYOUT_FILE})
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${DOXYGEN_INDEX_FILE_IN} ${DOXYGEN_OUTPUT_DIRECTORY}/${DOXYGEN_INDEX_FILE})

    file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/doxygen_website_customization/css/custom-bootstrap.css DESTINATION ${DOXYGEN_OUTPUT_DIRECTORY}/${DOXYGEN_CUSTOM_HTML_DIR})
    file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/doxygen_website_customization/js/doxy-boot.js DESTINATION ${DOXYGEN_OUTPUT_DIRECTORY}/${DOXYGEN_CUSTOM_HTML_DIR})

    add_custom_target(doc_website ALL
                      COMMAND "${DOXYGEN_EXECUTABLE}" "${DOXYGEN_OUTPUT_DIRECTORY}/${DOXYGEN_CONFIG_FILE}"
                      WORKING_DIRECTORY "${DOXYGEN_OUTPUT_DIRECTORY}"
                      COMMENT "Building documentation...")
    
    set_target_properties(doc_website PROPERTIES FOLDER "Documentation")
endif()

#########################################################################################

=== CherryPi/rttr/src/CMakeLists.txt ===
####################################################################################
#                                                                                  #
#  Copyright (c) 2014, 2015 - 2017 Axel Menzel <info@rttr.org>                     #
#                                                                                  #
#  This file is part of RTTR (Run Time Type Reflection)                            #
#  License: MIT License                                                            #
#                                                                                  #
#  Permission is hereby granted, free of charge, to any person obtaining           #
#  a copy of this software and associated documentation files (the "Software"),    #
#  to deal in the Software without restriction, including without limitation       #
#  the rights to use, copy, modify, merge, publish, distribute, sublicense,        #
#  and/or sell copies of the Software, and to permit persons to whom the           #
#  Software is furnished to do so, subject to the following conditions:            #
#                                                                                  #
#  The above copyright notice and this permission notice shall be included in      #
#  all copies or substantial portions of the Software.                             #
#                                                                                  #
#  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR      #
#  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,        #
#  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE     #
#  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER          #
#  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,   #
#  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE   #
#  SOFTWARE.                                                                       #
#                                                                                  #
####################################################################################

#############################################
# Include the core library, unit tests and
# the benchmarks
#############################################

add_subdirectory (rttr)

if (BUILD_UNIT_TESTS)
    add_subdirectory (unit_tests)
endif()

if (BUILD_BENCHMARKS)
    add_subdirectory (benchmarks)
endif()

if (BUILD_EXAMPLES)
    add_subdirectory (examples)
endif()

=== CherryPi/torchcraft/BWEnv/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)
project(BWEnv)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

set(CMAKE_SHARED_LIBRARY_PREFIX "")

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR})

if (USE_MINI_OPENBWAPI)
  find_path(OPENBW_DIR bwgame.h mini-openbwapi
    PATHS
    ENV OPENBW_DIR
    ../../../openbw
    ../../openbw
    ../openbw
  )
  
  if (NOT OPENBW_DIR)
    message(FATAL_ERROR "Couldn't find openbw. Specify the path to it with OPENBW_DIR environment variable")
  endif()
  
  add_subdirectory(${OPENBW_DIR}/mini-openbwapi mini-openbwapi)
  
  set(BWAPI_INCLUDE_DIRS ${OPENBW_DIR}/mini-openbwapi)
  set(BWAPI_LIBRARIES mini-openbwapi)
else()
  find_package(BWAPI REQUIRED)
endif()

include_directories(
  ${CMAKE_CURRENT_SOURCE_DIR}/include
  ${CMAKE_CURRENT_SOURCE_DIR}/fbs
  ${CMAKE_CURRENT_SOURCE_DIR}/../include
  ${BWAPI_INCLUDE_DIRS}
)

add_library(BWEnvObj OBJECT
  src/config_manager.cc
  src/controller.cc
  src/user_actions.cc
  src/utils.cc
  src/zmq_server.cc
  ../replayer/frame.cpp
)

set_property(TARGET BWEnvObj PROPERTY POSITION_INDEPENDENT_CODE ON)

if (NOT USE_MINI_OPENBWAPI)
  add_library(BWEnv SHARED
    src/dll.cc
    src/module.cc
    $<TARGET_OBJECTS:BWEnvObj>
  )
  
  target_link_libraries(BWEnv
    czmq
    ${BWAPI_LIBRARIES}
  )
endif()

add_executable(BWEnvClient
  src/main.cc
  $<TARGET_OBJECTS:BWEnvObj>
)

target_link_libraries(BWEnvClient
  czmq
  ${BWAPI_LIBRARIES}
)

=== CherryPi/rttr/src/benchmarks/CMakeLists.txt ===
####################################################################################
#                                                                                  #
#  Copyright (c) 2014, 2015 - 2017 Axel Menzel <info@rttr.org>                     #
#                                                                                  #
#  This file is part of RTTR (Run Time Type Reflection)                            #
#  License: MIT License                                                            #
#                                                                                  #
#  Permission is hereby granted, free of charge, to any person obtaining           #
#  a copy of this software and associated documentation files (the "Software"),    #
#  to deal in the Software without restriction, including without limitation       #
#  the rights to use, copy, modify, merge, publish, distribute, sublicense,        #
#  and/or sell copies of the Software, and to permit persons to whom the           #
#  Software is furnished to do so, subject to the following conditions:            #
#                                                                                  #
#  The above copyright notice and this permission notice shall be included in      #
#  all copies or substantial portions of the Software.                             #
#                                                                                  #
#  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR      #
#  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,        #
#  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE     #
#  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER          #
#  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,   #
#  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE   #
#  SOFTWARE.                                                                       #
#                                                                                  #
####################################################################################

if (Boost_FOUND)
    add_subdirectory (bench_method)
    add_subdirectory (bench_rttr_cast)
    add_subdirectory (bench_variant)
else()
    message(STATUS "Boost was not found - NO benchmark projectes created.")
endif()

=== CherryPi/rttr/src/examples/CMakeLists.txt ===
####################################################################################
#                                                                                  #
#  Copyright (c) 2014, 2015 - 2017 Axel Menzel <info@rttr.org>                     #
#                                                                                  #
#  This file is part of RTTR (Run Time Type Reflection)                            #
#  License: MIT License                                                            #
#                                                                                  #
#  Permission is hereby granted, free of charge, to any person obtaining           #
#  a copy of this software and associated documentation files (the "Software"),    #
#  to deal in the Software without restriction, including without limitation       #
#  the rights to use, copy, modify, merge, publish, distribute, sublicense,        #
#  and/or sell copies of the Software, and to permit persons to whom the           #
#  Software is furnished to do so, subject to the following conditions:            #
#                                                                                  #
#  The above copyright notice and this permission notice shall be included in      #
#  all copies or substantial portions of the Software.                             #
#                                                                                  #
#  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR      #
#  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,        #
#  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE     #
#  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER          #
#  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,   #
#  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE   #
#  SOFTWARE.                                                                       #
#                                                                                  #
####################################################################################

add_subdirectory (json_serialization)

=== CherryPi/rttr/src/rttr/CMakeLists.txt ===
####################################################################################
#                                                                                  #
#  Copyright (c) 2014, 2015 - 2017 Axel Menzel <info@rttr.org>                     #
#                                                                                  #
#  This file is part of RTTR (Run Time Type Reflection)                            #
#  License: MIT License                                                            #
#                                                                                  #
#  Permission is hereby granted, free of charge, to any person obtaining           #
#  a copy of this software and associated documentation files (the "Software"),    #
#  to deal in the Software without restriction, including without limitation       #
#  the rights to use, copy, modify, merge, publish, distribute, sublicense,        #
#  and/or sell copies of the Software, and to permit persons to whom the           #
#  Software is furnished to do so, subject to the following conditions:            #
#                                                                                  #
#  The above copyright notice and this permission notice shall be included in      #
#  all copies or substantial portions of the Software.                             #
#                                                                                  #
#  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR      #
#  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,        #
#  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE     #
#  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER          #
#  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,   #
#  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE   #
#  SOFTWARE.                                                                       #
#                                                                                  #
####################################################################################

project(rttr)

message(STATUS "Scanning "  ${PROJECT_NAME} " module.")
message(STATUS "===========================")

generateLibraryVersionVariables(${RTTR_VERSION_MAJOR} ${RTTR_VERSION_MINOR} ${RTTR_VERSION_PATCH}
                                "RTTR" "Copyright (c) 2014, 2015 - 2017 Axel Menzel <info@rttr.org>" "MIT License")

loadFolder("rttr" HPP_FILES SRC_FILES BUILD_INSTALLER)

if (USE_PCH)
    activate_precompiled_headers("detail/base/pch.h" SRC_FILES)
endif()

if (${BUILD_RTTR_DYNAMIC})
    add_library(rttr_core SHARED ${UnityBuild} ${SRC_FILES} ${HPP_FILES})
    add_library(RTTR::Core ALIAS rttr_core)
    
    target_compile_definitions(rttr_core PRIVATE RTTR_DLL_EXPORTS)
    target_compile_definitions(rttr_core PUBLIC RTTR_DLL)

    set_target_properties(rttr_core PROPERTIES
                          VERSION ${RTTR_VERSION} SOVERSION ${RTTR_VERSION}
                          EXPORT_NAME Core)
                          
    target_include_directories(rttr_core PUBLIC
                               $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/../>
                               $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../>
                               $<INSTALL_INTERFACE:include>)
                               
    if (BUILD_INSTALLER)
        install(TARGETS rttr_core EXPORT rttr_targets
                RUNTIME DESTINATION ${RTTR_BIN_INSTALL_DIR}
                LIBRARY DESTINATION ${RTTR_BIN_INSTALL_DIR}
                ARCHIVE DESTINATION ${RTTR_LIB_INSTALL_DIR})

        install(EXPORT rttr_targets
                DESTINATION cmake
                NAMESPACE RTTR::
                FILE rttr-config.cmake)
            
        # install also pdb file
        install_pdb_files(rttr_core)
    endif()

endif()

if (BUILD_STATIC)
    add_library(rttr_core_lib STATIC ${UnityBuild} ${SRC_FILES} ${HPP_FILES})
    add_library(RTTR::Core_Lib ALIAS rttr_core_lib)
    
    set_target_properties(rttr_core_lib PROPERTIES
                          VERSION ${RTTR_VERSION} SOVERSION ${RTTR_VERSION}
                          EXPORT_NAME Core_Lib)
    if (MSVC)
        set_target_properties(rttr_core_lib PROPERTIES OUTPUT_NAME librttr_core)
    elseif (CMAKE_COMPILER_IS_GNUCXX)
        set_target_properties(rttr_core_lib PROPERTIES OUTPUT_NAME rttr_core)
    elseif (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
        set_target_properties(rttr_core_lib PROPERTIES OUTPUT_NAME rttr_core)
    else()
        message(SEND_ERROR "Do now know how to to name the static library.")
    endif()
    
    target_include_directories(rttr_core_lib PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/../>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../>
    $<INSTALL_INTERFACE:include>)
    
    if (BUILD_INSTALLER)
        install(TARGETS rttr_core_lib EXPORT rttr_targets
                ARCHIVE DESTINATION ${RTTR_LIB_INSTALL_DIR}
                LIBRARY DESTINATION ${RTTR_LIB_INSTALL_DIR})
    endif()
endif()

if (BUILD_WITH_STATIC_RUNTIME_LIBS)
    add_library(rttr_core_s SHARED ${UnityBuild} ${SRC_FILES} ${HPP_FILES})
    add_library(RTTR::Core_STL ALIAS rttr_core_s)
    
    target_compile_definitions(rttr_core_s PRIVATE RTTR_DLL_EXPORTS)
    target_compile_definitions(rttr_core_s PUBLIC RTTR_DLL)

    target_include_directories(rttr_core_s PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/../>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../>
    $<INSTALL_INTERFACE:include>)

    set_target_properties(rttr_core_s PROPERTIES
                          VERSION ${RTTR_VERSION} SOVERSION ${RTTR_VERSION}
                          EXPORT_NAME Core_STL)
                          
    if (MSVC)
        target_compile_options(rttr_core_s PUBLIC "/MT$<$<CONFIG:Debug>:d>")
    elseif(CMAKE_COMPILER_IS_GNUCXX)
        set_target_properties(rttr_core_s PROPERTIES LINK_FLAGS ${GNU_STATIC_LINKER_FLAGS})
    elseif (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
        set_target_properties(rttr_core_s PROPERTIES LINK_FLAGS ${CLANG_STATIC_LINKER_FLAGS})
    else()
        message(SEND_ERROR "Do now know how to statically link against the standard library with this compiler.")
    endif()

    if (BUILD_INSTALLER)
        install_pdb_files(rttr_core_s)
        install(TARGETS rttr_core_s EXPORT rttr_targets
                RUNTIME DESTINATION ${RTTR_BIN_INSTALL_DIR}
                LIBRARY DESTINATION ${RTTR_BIN_INSTALL_DIR}
                ARCHIVE DESTINATION ${RTTR_LIB_INSTALL_DIR})
    endif()
    
    if (BUILD_STATIC)
        add_library(rttr_core_lib_s STATIC ${UnityBuild} ${SRC_FILES} ${HPP_FILES})
        add_library(RTTR::Core_Lib_STL ALIAS rttr_core_lib_s)
        
        target_include_directories(rttr_core_lib_s PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/../>
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/../>
        $<INSTALL_INTERFACE:include>)

        set_target_properties(rttr_core_lib_s PROPERTIES
                              VERSION ${RTTR_VERSION} SOVERSION ${RTTR_VERSION}
                              EXPORT_NAME Core_Lib_STL)
        if (MSVC)
            target_compile_options(rttr_core_lib_s PUBLIC "/MT$<$<CONFIG:Debug>:d>")
            set_target_properties(rttr_core_lib PROPERTIES OUTPUT_NAME librttr_core_s)
        elseif(CMAKE_COMPILER_IS_GNUCXX)
            set_target_properties(rttr_core_lib_s PROPERTIES LINK_FLAGS ${GNU_STATIC_LINKER_FLAGS} OUTPUT_NAME rttr_core_s)
        elseif (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
            set_target_properties(rttr_core_lib_s PROPERTIES LINK_FLAGS ${CLANG_STATIC_LINKER_FLAGS} OUTPUT_NAME rttr_core_s)
        else()
            message(SEND_ERROR "Do now know how to statically link against the standard library with this compiler.")
        endif()
        
        if (BUILD_INSTALLER)
            install(TARGETS rttr_core_lib_s EXPORT rttr_targets
                    ARCHIVE DESTINATION ${RTTR_LIB_INSTALL_DIR}
                    LIBRARY DESTINATION ${RTTR_LIB_INSTALL_DIR})
        endif()

    endif()
endif()

message(STATUS "Scanning " ${PROJECT_NAME} " module finished!")
message(STATUS "")

=== CherryPi/rttr/src/unit_tests/CMakeLists.txt ===
####################################################################################
#                                                                                  #
#  Copyright (c) 2014, 2015 - 2017 Axel Menzel <info@rttr.org>                     #
#                                                                                  #
#  This file is part of RTTR (Run Time Type Reflection)                            #
#  License: MIT License                                                            #
#                                                                                  #
#  Permission is hereby granted, free of charge, to any person obtaining           #
#  a copy of this software and associated documentation files (the "Software"),    #
#  to deal in the Software without restriction, including without limitation       #
#  the rights to use, copy, modify, merge, publish, distribute, sublicense,        #
#  and/or sell copies of the Software, and to permit persons to whom the           #
#  Software is furnished to do so, subject to the following conditions:            #
#                                                                                  #
#  The above copyright notice and this permission notice shall be included in      #
#  all copies or substantial portions of the Software.                             #
#                                                                                  #
#  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR      #
#  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,        #
#  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE     #
#  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER          #
#  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,   #
#  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE   #
#  SOFTWARE.                                                                       #
#                                                                                  #
####################################################################################

project(unit_tests)

message(STATUS "Scanning "  ${PROJECT_NAME} " module.")
message(STATUS "===========================")

generateLibraryVersionVariables(${RTTR_VERSION_MAJOR} ${RTTR_VERSION_MINOR} ${RTTR_VERSION_PATCH}
                                "RTTR unit_tests" "Copyright (c) 2014, 2015 - 2017 Axel Menzel <info@rttr.org>" "MIT License")

loadFolder("unit_tests" HPP_FILES SRC_FILES)

if (USE_PCH)
  activate_precompiled_headers("pch.h" SRC_FILES)
endif()

add_executable(unit_tests ${SRC_FILES} ${HPP_FILES})
target_link_libraries(unit_tests RTTR::Core)
add_dependencies(unit_tests RTTR::Core)
target_include_directories(unit_tests PUBLIC ${CATCH_DIR})
set_target_properties(unit_tests PROPERTIES DEBUG_POSTFIX _d)

# run tests
add_custom_target(run_tests ALL
                  COMMAND "$<TARGET_FILE:unit_tests>"
                  DEPENDS unit_tests
                  COMMENT "Running unit_tests")


message(STATUS "Scanning " ${PROJECT_NAME} " module finished!")
message(STATUS "")

=== CherryPi/torchcraft/examples/cpp/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.6 FATAL_ERROR)
CMAKE_POLICY(VERSION 2.6)

SET(CMAKE_CXX_FLAGS "-std=c++11 -Wall")

FIND_PACKAGE(Torch REQUIRED)
FIND_PACKAGE(gflags REQUIRED)
INCLUDE_DIRECTORIES("${Torch_INSTALL_INCLUDE}/torchcraft")

ADD_EXECUTABLE(simple_dll simple_dll.cpp)
TARGET_LINK_LIBRARIES(simple_dll torchcraft gflags)

=== CherryPi/rttr/src/benchmarks/bench_method/CMakeLists.txt ===
####################################################################################
#                                                                                  #
#  Copyright (c) 2014, 2015 - 2017 Axel Menzel <info@rttr.org>                     #
#                                                                                  #
#  This file is part of RTTR (Run Time Type Reflection)                            #
#  License: MIT License                                                            #
#                                                                                  #
#  Permission is hereby granted, free of charge, to any person obtaining           #
#  a copy of this software and associated documentation files (the "Software"),    #
#  to deal in the Software without restriction, including without limitation       #
#  the rights to use, copy, modify, merge, publish, distribute, sublicense,        #
#  and/or sell copies of the Software, and to permit persons to whom the           #
#  Software is furnished to do so, subject to the following conditions:            #
#                                                                                  #
#  The above copyright notice and this permission notice shall be included in      #
#  all copies or substantial portions of the Software.                             #
#                                                                                  #
#  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR      #
#  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,        #
#  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE     #
#  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER          #
#  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,   #
#  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE   #
#  SOFTWARE.                                                                       #
#                                                                                  #
####################################################################################

project(bench_method)

message(STATUS "Scanning "  ${PROJECT_NAME} " module.")
message(STATUS "===========================")

generateLibraryVersionVariables(${RTTR_VERSION_MAJOR} ${RTTR_VERSION_MINOR} ${RTTR_VERSION_PATCH}
                                "Benchmark method" "Copyright (c) 2014, 2015 - 2017 Axel Menzel <info@rttr.org>" "MIT License")

loadFolder("bench_method" HPP_FILES SRC_FILES)

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../)

if (USE_PCH)
  activate_precompiled_headers("pch.h" SRC_FILES)
endif()

add_executable(bench_method ${SRC_FILES} ${HPP_FILES})
if (MSVC)
  target_link_libraries(bench_method RTTR::Core ${Boost_CHRONO_LIBRARY} ${Boost_SYSTEM_LIBRARY})
else()
  target_link_libraries(bench_method RTTR::Core ${CMAKE_THREAD_LIBS_INIT})
endif()

target_include_directories(bench_method PUBLIC ${NONIUS_DIR} ${Boost_INCLUDE_DIR})
target_compile_definitions(bench_method PUBLIC BOOST_ALL_NO_LIB)
if(MSVC)
    set_target_properties(bench_method PROPERTIES COMPILE_FLAGS "/Zm200")
endif()

set_target_properties(bench_method PROPERTIES DEBUG_POSTFIX _d
                                              FOLDER "Benchmarks")
add_dependencies(bench_method RTTR::Core)

install(TARGETS bench_method
        RUNTIME DESTINATION ${RTTR_BIN_INSTALL_DIR})

###############################################################################

if (BUILD_STATIC)
    add_executable(bench_method_lib ${SRC_FILES} ${HPP_FILES})
    if (MSVC)
      target_link_libraries(bench_method_lib RTTR::Core_Lib ${Boost_CHRONO_LIBRARY} ${Boost_SYSTEM_LIBRARY} )
    else()
      target_link_libraries(bench_method_lib RTTR::Core_Lib ${CMAKE_THREAD_LIBS_INIT})
    endif()

    target_include_directories(bench_method_lib PUBLIC ${NONIUS_DIR} ${Boost_INCLUDE_DIR})
    target_compile_definitions(bench_method_lib PUBLIC BOOST_ALL_NO_LIB)
    if(MSVC)
        set_target_properties(bench_method_lib PROPERTIES COMPILE_FLAGS "/Zm200 /bigobj")
    endif()

    set_target_properties(bench_method_lib PROPERTIES DEBUG_POSTFIX _d
                                                      FOLDER "Benchmarks")

    add_dependencies(bench_method_lib RTTR::Core_Lib)

    install(TARGETS bench_method_lib
            RUNTIME DESTINATION ${RTTR_BIN_INSTALL_DIR})
endif()

###############################################################################

if (BUILD_WITH_STATIC_RUNTIME_LIBS)
    add_executable(bench_method_s ${SRC_FILES} ${HPP_FILES})
    if (MSVC)
      target_link_libraries(bench_method_s RTTR::Core_STL ${Boost_CHRONO_LIBRARY} ${Boost_SYSTEM_LIBRARY} )
    else()
      target_link_libraries(bench_method_s RTTR::Core_STL ${CMAKE_THREAD_LIBS_INIT})
    endif()

    target_include_directories(bench_method_s PUBLIC ${NONIUS_DIR} ${Boost_INCLUDE_DIR})
    target_compile_definitions(bench_method_s PUBLIC BOOST_ALL_NO_LIB)
    if(MSVC)
        set_target_properties(bench_method_s PROPERTIES COMPILE_FLAGS "/Zm200 /bigobj")
    endif()

    set_target_properties(bench_method_s PROPERTIES DEBUG_POSTFIX _d
                                                    FOLDER "Benchmarks")

    add_dependencies(bench_method_s RTTR::Core_STL)

    if (MSVC)
        target_compile_options(bench_method_s PUBLIC "/MT$<$<CONFIG:Debug>:d>")
    elseif(CMAKE_COMPILER_IS_GNUCXX)
        set_target_properties(bench_method_s PROPERTIES LINK_FLAGS ${GNU_STATIC_LINKER_FLAGS})
    elseif (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
        set_target_properties(bench_method_s PROPERTIES LINK_FLAGS ${CLANG_STATIC_LINKER_FLAGS})
    else()
        message(SEND_ERROR "Do now know how to statically link against the standard library with this compiler.")
    endif()

    install(TARGETS bench_method_s
            RUNTIME DESTINATION ${RTTR_BIN_INSTALL_DIR})

    if (BUILD_STATIC)
        add_executable(bench_method_lib_s ${SRC_FILES} ${HPP_FILES})
        if (MSVC)
          target_link_libraries(bench_method_lib_s RTTR::Core_Lib_STL ${Boost_CHRONO_LIBRARY} ${Boost_SYSTEM_LIBRARY} )
        else()
          target_link_libraries(bench_method_lib_s RTTR::Core_Lib_STL ${CMAKE_THREAD_LIBS_INIT})
        endif()

        target_include_directories(bench_method_lib_s PUBLIC ${NONIUS_DIR} ${Boost_INCLUDE_DIR})
        target_compile_definitions(bench_method_lib_s PUBLIC BOOST_ALL_NO_LIB)
        if(MSVC)
            set_target_properties(bench_method_lib_s PROPERTIES COMPILE_FLAGS "/Zm200 /bigobj")
        endif()

        set_target_properties(bench_method_lib_s PROPERTIES DEBUG_POSTFIX _d
                                                            FOLDER "Benchmarks")

        add_dependencies(bench_method_lib_s RTTR::Core_Lib_STL)

        if (MSVC)
            target_compile_options(bench_method_lib_s PUBLIC "/MT$<$<CONFIG:Debug>:d>")
        elseif(CMAKE_COMPILER_IS_GNUCXX)
            set_target_properties(bench_method_lib_s PROPERTIES LINK_FLAGS ${GNU_STATIC_LINKER_FLAGS})
        elseif (CMAKE_CXX_COMPILER_ID MATCHES "Clang")
            set_target_properties(bench_method_lib_s PROPERTIES LINK_FLAGS ${CLANG_STATIC_LINKER_FLAGS})
        else()
            message(SEND_ERROR "Do now know how to statically link against the standard library with this compiler.")
        endif()

        install(TARGETS bench_method_lib_s
                RUNTIME DESTINATION ${RTTR_BIN_INSTALL_DIR})
    endif()
endif()

message(STATUS "Scanning " ${PROJECT_NAME} " module finished!")
message(STATUS "")

=== CherryPi/torchcraft/BWEnv/include/czmq/packaging/debian/changelog ===
czmq (4.0.1) UNRELEASED; urgency=low

  * Initial packaging.

 -- czmq Developers <zeromq-dev@lists.zeromq.org>  Wed, 31 Dec 2014 00:00:00 +0000

=== CherryPi/torchcraft/BWEnv/include/libzmq/packaging/debian/changelog ===
zeromq (4.2.0) UNRELEASED; urgency=low

  * Initial packaging.

 -- libzmq Developers <zeromq-dev@lists.zeromq.org>  Wed, 31 Dec 2014 00:00:00 +0000

=== CherryPi/torchcraft/BWEnv/include/czmq/packaging/debian/control ===
#
#    czmq - The high-level C binding for 0MQ
#
#    Copyright (c) the Contributors as noted in the AUTHORS file.       
#    This file is part of CZMQ, the high-level C binding for 0MQ:       
#    http://czmq.zeromq.org.                                            
#                                                                       
#    This Source Code Form is subject to the terms of the Mozilla Public
#    License, v. 2.0. If a copy of the MPL was not distributed with this
#    file, You can obtain one at http://mozilla.org/MPL/2.0/.           

Source:         czmq
Section:        net
Priority:       optional
Maintainer:     czmq Developers <zeromq-dev@lists.zeromq.org>
Standards-Version: 3.9.7
Build-Depends: debhelper (>= 9),
    pkg-config,
    dh-autoreconf,
    libzmq3-dev,
    uuid-dev,
    libsystemd-dev,
Build-Depends-Indep: asciidoc,
                     xmlto

Package: libczmq4
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: czmq
 This package contains shared library for czmq: the high-level c binding for 0mq

Package: libczmq-dev
Architecture: any
Section: libdevel
Depends:
    libzmq3-dev,
    uuid-dev,
    libsystemd-dev,
    libczmq4 (= ${binary:Version})
Description: development files for czmq
 This package contains development files for czmq: the high-level c binding for 0mq

Package: czmq
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: the high-level c binding for 0mq
 Main package for czmq: the high-level c binding for 0mq

Package: czmq-dbg
Architecture: any
Section: debug
Priority: extra
Depends:
    czmq (= ${binary:Version}),
    ${misc:Depends}
Description: debugging symbols for czmq
 This package contains the debugging symbols for czmq : the high-level c binding for 0mq.

=== CherryPi/torchcraft/BWEnv/include/libzmq/packaging/debian/control ===
Source: zeromq
Section: libs
Priority: optional
Maintainer: libzmq Developers <zeromq-dev@lists.zeromq.org>
Build-Depends: debhelper (>= 9),
 dh-autoreconf,
 libpgm-dev,
 libsodium-dev,
 libunwind-dev | libunwind7-dev,
 pkg-config
Standards-Version: 3.9.8
Homepage: http://www.zeromq.org/

Package: libzmq5
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: lightweight messaging kernel (shared library)
 ØMQ is a library which extends the standard socket interfaces with features
 traditionally provided by specialised messaging middleware products.
 .
 ØMQ sockets provide an abstraction of asynchronous message queues, multiple
 messaging patterns, message filtering (subscriptions), seamless access to
 multiple transport protocols and more.
 .
 This package contains the libzmq shared library.

Package: libzmq3-dev
Architecture: any
Section: libdevel
Depends: libzmq5 (= ${binary:Version}), ${misc:Depends}
Conflicts: libzmq-dev, libzmq5-dev
Replaces: libzmq5-dev
Provides: libzmq5-dev
Multi-Arch: same
Description: lightweight messaging kernel (development files)
 ØMQ is a library which extends the standard socket interfaces with features
 traditionally provided by specialised messaging middleware products.
 .
 ØMQ sockets provide an abstraction of asynchronous message queues, multiple
 messaging patterns, message filtering (subscriptions), seamless access to
 multiple transport protocols and more.
 .
 This package contains the ZeroMQ development libraries and header files.

Package: libzmq5-dbg
Architecture: any
Priority: extra
Section: debug
Depends: libzmq5 (= ${binary:Version}), ${misc:Depends}
Multi-Arch: same
Description: lightweight messaging kernel (debugging symbols)
 ØMQ is a library which extends the standard socket interfaces with features
 traditionally provided by specialised messaging middleware products.
 .
 ØMQ sockets provide an abstraction of asynchronous message queues, multiple
 messaging patterns, message filtering (subscriptions), seamless access to
 multiple transport protocols and more.
 .
 This package contains the debugging symbols for the ZeroMQ library.

=== CherryPi/torchcraft/BWEnv/include/czmq/packaging/debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

DRAFTS=no

# OBS build: add
#   Macros:
#   %_with_drafts 1
# at the BOTTOM of the OBS prjconf
OBS_BUILD_CFG=/.build/build.dist
ifeq ("$(wildcard $(OBS_BUILD_CFG))","")
BUILDCONFIG=$(shell ls -1 /usr/src/packages/SOURCES/_buildconfig* | head -n 1)
endif
ifneq ("$(wildcard $(OBS_BUILD_CFG))","")
ifneq ("$(shell grep drafts $(OBS_BUILD_CFG))","")
DRAFTS=yes
endif
endif

# User build: DEB_BUILD_OPTIONS=drafts dpkg-buildpackage
ifneq (,$(findstring drafts,$(DEB_BUILD_OPTIONS)))
DRAFTS=yes
endif

override_dh_strip:
	dh_strip --dbg-package=czmq-dbg

override_dh_auto_test:
	echo "Skipped for now"

override_dh_auto_configure:
	dh_auto_configure -- \
		--enable-drafts=$(DRAFTS)

%:
	dh $@ \
		--with autoreconf

=== CherryPi/torchcraft/BWEnv/include/libzmq/packaging/debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export TEST_VERBOSE=1

ifeq ($(DEB_BUILD_ARCH_OS), kfreebsd)
	DO_TEST = no
endif

DRAFTS=no

# OBS build: add
#   Macros:
#   %_with_drafts 1
# at the BOTTOM of the OBS prjconf
OBS_BUILD_CFG=/.build/build.dist
ifeq ("$(wildcard $(OBS_BUILD_CFG))","")
BUILDCONFIG=$(shell ls -1 /usr/src/packages/SOURCES/_buildconfig* | head -n 1)
endif
ifneq ("$(wildcard $(OBS_BUILD_CFG))","")
ifneq ("$(shell grep drafts $(OBS_BUILD_CFG))","")
DRAFTS=yes
endif
endif

# User build: DEB_BUILD_OPTIONS=drafts dpkg-buildpackage
ifneq (,$(findstring drafts,$(DEB_BUILD_OPTIONS)))
DRAFTS=yes
endif

override_dh_clean:
	dh_clean
	find $(CURDIR) -type s -exec rm {} \;
	rm -f $(CURDIR)/doc/*.xml $(CURDIR)/doc/*.3 $(CURDIR)/doc/*.7
	rm -f config.log

override_dh_auto_configure:
	dh_auto_configure -- --with-pgm --with-libsodium --enable-drafts=$(DRAFTS)

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
ifneq ($(DO_TEST), no)
	-dh_auto_test -- VERBOSE=1
else
	-dh_auto_test -- VERBOSE=1
endif
endif

override_dh_strip:
	dh_strip --dbg-package=libzmq5-dbg

%:
	dh $@ --with=autoreconf --parallel

.PHONY: override_dh_auto_configure override_dh_strip
